ServletForwardingController (Spring Framework 3.2.1.RELEASE API)
Date: 2013-01-24

org.springframework.web.servlet.mvc

## Class ServletForwardingController

- java.lang.Object
- - org.springframework.context.support.ApplicationObjectSupport
  - - org.springframework.web.context.support.WebApplicationObjectSupport
    - - org.springframework.web.servlet.support.WebContentGenerator
      - - org.springframework.web.servlet.mvc.AbstractController
        - - org.springframework.web.servlet.mvc.ServletForwardingController

- All Implemented Interfaces:
    Aware, BeanNameAware, ApplicationContextAware, ServletContextAware, Controller

      public class ServletForwardingController
      extends AbstractController
      implements BeanNameAware

  Spring Controller implementation that forwards to a named servlet, i.e. the "servlet-name" in web.xml rather than a URL path mapping. A target servlet doesn't even need a "servlet-mapping" in web.xml in the first place: A "servlet" declaration is sufficient.

  Useful to invoke an existing servlet via Spring's dispatching infrastructure, for example to apply Spring HandlerInterceptors to its requests. This will work even in a minimal Servlet container that does not support Servlet filters.

  Example: web.xml, mapping all "/myservlet" requests to a Spring dispatcher. Also defines a custom "myServlet", but without servlet mapping.

       <servlet>
         <servlet-name>myServlet</servlet-name>
         <servlet-class>mypackage.TestServlet</servlet-class>
       </servlet>

       <servlet>
         <servlet-name>myDispatcher</servlet-name>
         <servlet-class>org.springframework.web.servlet.DispatcherServlet</servlet-class>
       </servlet>

       <servlet-mapping>
         <servlet-name>myDispatcher</servlet-name>
         <url-pattern>/myservlet</url-pattern>
       </servlet-mapping>

  Example: myDispatcher-servlet.xml, in turn forwarding "/myservlet" to your servlet (identified by servlet name). All such requests will go through the configured HandlerInterceptor chain (e.g. an OpenSessionInViewInterceptor). From the servlet point of view, everything will work as usual.

       <bean id="urlMapping" class="org.springframework.web.servlet.handler.SimpleUrlHandlerMapping">
         <property name="interceptors">
           <list>
             <ref bean="openSessionInViewInterceptor"/>
           </list>
         </property>
         <property name="mappings">
           <props>
             <prop key="/myservlet">myServletForwardingController</prop>
           </props>
         </property>
       </bean>

       <bean id="myServletForwardingController" class="org.springframework.web.servlet.mvc.ServletForwardingController">
         <property name="servletName"><value>myServlet</value></property>
       </bean>

  Since:
    1.1.1
  Author:
    Juergen Hoeller
  See Also:
    `ServletWrappingController`, `OpenSessionInViewInterceptor`, `OpenSessionInViewFilter`, `OpenPersistenceManagerInViewInterceptor`, `OpenPersistenceManagerInViewFilter`

- - ### Field Summary

    - ### Fields inherited from class org.springframework.web.servlet.support.WebContentGenerator

      `METHOD_GET, METHOD_HEAD, METHOD_POST`

    - ### Fields inherited from class org.springframework.context.support.ApplicationObjectSupport

      `logger`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ServletForwardingController()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected ModelAndView` | `handleRequestInternal(HttpServletRequest request, HttpServletResponse response)` Template method.
    `void` | `setBeanName(String name)` Set the name of the bean in the bean factory that created this bean.
    `void` | `setServletName(String servletName)` Set the name of the servlet to forward to, i.e.
    `protected boolean` | `useInclude(HttpServletRequest request, HttpServletResponse response)` Determine whether to use RequestDispatcher's `include` or `forward` method.

    - ### Methods inherited from class org.springframework.web.servlet.mvc.AbstractController

      `handleRequest, isSynchronizeOnSession, setSynchronizeOnSession`

    - ### Methods inherited from class org.springframework.web.servlet.support.WebContentGenerator

      `applyCacheSeconds, applyCacheSeconds, cacheForSeconds, cacheForSeconds, checkAndPrepare, checkAndPrepare, getCacheSeconds, getSupportedMethods, isAlwaysMustRevalidate, isRequireSession, isUseCacheControlHeader, isUseCacheControlNoStore, isUseExpiresHeader, preventCaching, setAlwaysMustRevalidate, setCacheSeconds, setRequireSession, setSupportedMethods, setUseCacheControlHeader, setUseCacheControlNoStore, setUseExpiresHeader`

    - ### Methods inherited from class org.springframework.web.context.support.WebApplicationObjectSupport

      `getServletContext, getTempDir, getWebApplicationContext, initApplicationContext, initServletContext, isContextRequired, setServletContext`

    - ### Methods inherited from class org.springframework.context.support.ApplicationObjectSupport

      `getApplicationContext, getMessageSourceAccessor, initApplicationContext, requiredContextClass, setApplicationContext`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### ServletForwardingController

          public ServletForwardingController()

  - ### Method Detail

    - #### setServletName

          public void setServletName(String servletName)

      Set the name of the servlet to forward to, i.e. the "servlet-name" of the target servlet in web.xml.

      Default is the bean name of this controller.

    - #### setBeanName

          public void setBeanName(String name)

      Description copied from interface: `BeanNameAware`
      Set the name of the bean in the bean factory that created this bean.

      Invoked after population of normal bean properties but before an init callback such as `InitializingBean.afterPropertiesSet()` or a custom init-method.

      Specified by:
        `setBeanName` in interface `BeanNameAware`
      Parameters:
        `name` - the name of the bean in the factory. Note that this name is the actual bean name used in the factory, which may differ from the originally specified name: in particular for inner bean names, the actual bean name might have been made unique through appending "#..." suffixes. Use the `BeanFactoryUtils.originalBeanName(String)` method to extract the original bean name (without suffix), if desired.

    - #### handleRequestInternal

          protected ModelAndView handleRequestInternal(HttpServletRequest request,
                                           HttpServletResponse response)
                                                throws Exception

      Description copied from class: `AbstractController`
      Template method. Subclasses must implement this. The contract is the same as for `handleRequest`.
      Specified by:
        `handleRequestInternal` in class `AbstractController`
      Throws:
        `Exception`
      See Also:
        `AbstractController.handleRequest(javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)`

    - #### useInclude

          protected boolean useInclude(HttpServletRequest request,
                           HttpServletResponse response)

      Determine whether to use RequestDispatcher's `include` or `forward` method.

      Performs a check whether an include URI attribute is found in the request, indicating an include request, and whether the response has already been committed. In both cases, an include will be performed, as a forward is not possible anymore.

      Parameters:
        `request` - current HTTP request
        `response` - current HTTP response
      Returns:
        `true` for include, `false` for forward
      See Also:
        `RequestDispatcher.forward(javax.servlet.ServletRequest, javax.servlet.ServletResponse)`, `RequestDispatcher.include(javax.servlet.ServletRequest, javax.servlet.ServletResponse)`, `ServletResponse.isCommitted()`, `WebUtils.isIncludeRequest(javax.servlet.ServletRequest)`